import java.util.Calendar;
import com.sun.star.beans.PropertyValue;
import com.sun.star.beans.XPropertySet;
import com.sun.star.bridge.XUnoUrlResolver;
import com.sun.star.comp.helper.Bootstrap;
import com.sun.star.connection.NoConnectException;
import com.sun.star.document.XDocumentInfo;
import com.sun.star.document.XDocumentInfoSupplier;
import com.sun.star.frame.XComponentLoader;
import com.sun.star.frame.XStorable;
import com.sun.star.io.IOException;
import com.sun.star.lang.XComponent;
import com.sun.star.lang.XMultiComponentFactory;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XComponentContext;



public class TextDocument {

	   private static String unoUrl = "uno:socket,host=localhost,port=8100;urp;StarOffice.ServiceManager";


	   private static XMultiComponentFactory xRemoteServiceManager;


	   public static void main(String[] args){
			XComponentContext xLocalContext = null;
			Object remoteContext = null;
			XComponent xSpreadsheetComponent = null;
			try{
				xLocalContext = Bootstrap.createInitialComponentContext(null);
				XMultiComponentFactory xLocalServiceManager = xLocalContext.getServiceManager();
				Object urlResolver  = xLocalServiceManager.createInstanceWithContext("com.sun.star.bridge.UnoUrlResolver",xLocalContext);
				XUnoUrlResolver xUnoUrlResolver = (XUnoUrlResolver) UnoRuntime.queryInterface(XUnoUrlResolver.class,urlResolver);
				Object initialObject = xUnoUrlResolver.resolve(unoUrl);
				XPropertySet xPropertySet = (XPropertySet) UnoRuntime.queryInterface(XPropertySet.class,initialObject);
				remoteContext = xPropertySet.getPropertyValue("DefaultContext");

				XComponentContext xremoteContext = (XComponentContext) UnoRuntime.queryInterface(XComponentContext.class, remoteContext);

				xRemoteServiceManager = xremoteContext.getServiceManager();
				Object desktop = xRemoteServiceManager.createInstanceWithContext("com.sun.star.frame.Desktop", xremoteContext);

				XComponentLoader xComponentLoader = (XComponentLoader)UnoRuntime.queryInterface(XComponentLoader.class, desktop);

				PropertyValue[] loadProps = new PropertyValue[1];
				loadProps[0] = new PropertyValue();
				loadProps[0].Name = "Hidden";
				loadProps[0].Value = new Boolean(true);

				StringBuffer url = new StringBuffer ("file:///");
				url.append ("C:/testTemplate.ots");
				String loadUrl = url.toString();

				xSpreadsheetComponent = xComponentLoader.loadComponentFromURL(loadUrl, "_default", 0, loadProps);

				long time = System.currentTimeMillis();
				String timeStr = Long.toString(time);
				String storeUrlXL = "file:///C:/testDocument" + timeStr + ".xls";
				String storeUrlPDF= "file:///C:/testDocument" + timeStr + ".pdf";
				storeDocumentA(storeUrlXL,xSpreadsheetComponent);
				storeDocumentB (storeUrlPDF,xSpreadsheetComponent);

			}catch(NoConnectException e){
				e.printStackTrace();
			}catch(java.lang.Exception e){
				e.printStackTrace();
			}

			System.out.println("main end");
			System.exit(0);
	   }




	  private static void storeDocumentA (String storeUrl, XComponent xSpreadsheetComponent) {

			try {

				PropertyValue[] storeProps = new PropertyValue[1];
				storeProps[0] = new PropertyValue();
				storeProps[0].Name = "FilterName";
				storeProps[0].Value = "MS Excel 97";

				XStorable xStorable = (XStorable) UnoRuntime.queryInterface (XStorable.class, xSpreadsheetComponent);
				XDocumentInfoSupplier infoSupp = (XDocumentInfoSupplier)UnoRuntime.queryInterface(XDocumentInfoSupplier.class,xSpreadsheetComponent);
				XDocumentInfo docInfo = infoSupp.getDocumentInfo();
				XPropertySet docinfoProps =  (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class,docInfo);

				Calendar calendar = Calendar.getInstance();
				int month =  calendar.get(Calendar.MONTH);
				int day =  calendar.get(Calendar.DAY_OF_MONTH);
				int year = calendar.get(Calendar.YEAR);
				String value = day + "/ " + month + "/ " + year + ": Test Title";

				docinfoProps.setPropertyValue("Title", value);
				docinfoProps.setPropertyValue("Author", "Test Author");
				docinfoProps.setPropertyValue("Subject","Test Subject");
				docinfoProps.setPropertyValue("Description","Test Description");
				docinfoProps.setPropertyValue("Keywords","Generated Report ");
				xStorable.storeToURL (storeUrl, storeProps);

				System.out.println("the title is: " + (String)docinfoProps.getPropertyValue("Title"));
				System.out.println("the author is: " + (String)docinfoProps.getPropertyValue("Author"));
				System.out.println("the subject is: " + (String)docinfoProps.getPropertyValue("Subject"));
				System.out.println("the description is: " + (String)docinfoProps.getPropertyValue("Description"));
		        System.out.println("the keywords are: " + (String)docinfoProps.getPropertyValue("Keywords"));

			} catch (IOException e) {
				e.printStackTrace();
			}catch(Exception e){
				e.printStackTrace();
			}
		}



	  private static void storeDocumentB (String storeUrl, XComponent xSpreadsheetComponent) {

		 	try {

				PropertyValue[] storeProps = new PropertyValue[2];

				storeProps[0] = new PropertyValue();
				storeProps[0].Name = "FilterName";
				storeProps[0].Value = "calc_pdf_Export";

				storeProps[1] = new PropertyValue();
				storeProps[1].Name = "CompressMode";
				storeProps[1].Value = Integer.valueOf(0);

		   		XStorable xStorable = (XStorable) UnoRuntime.queryInterface (XStorable.class, xSpreadsheetComponent);
		   		XDocumentInfoSupplier infoSupp = (XDocumentInfoSupplier)UnoRuntime.queryInterface(XDocumentInfoSupplier.class,xSpreadsheetComponent);
		        XDocumentInfo docInfo = infoSupp.getDocumentInfo();
		        XPropertySet docinfoProps =  (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class,docInfo);

		        Calendar calendar = Calendar.getInstance();
		        int month =  calendar.get(Calendar.MONTH);
		        int day =  calendar.get(Calendar.DAY_OF_MONTH);
		        int year = calendar.get(Calendar.YEAR);
		        String value = day + "/ " + month + "/ " + year + ": Test company";

		        docinfoProps.setPropertyValue("Title", value);
				docinfoProps.setPropertyValue("Author", "Test Company");
				docinfoProps.setPropertyValue("Subject","Test Document");
				docinfoProps.setPropertyValue("Description","1343894384783");
				docinfoProps.setPropertyValue("Keywords","Generated Report ");
		        xStorable.storeToURL (storeUrl, storeProps);

		        System.out.println("the title is: " + (String)docinfoProps.getPropertyValue("Title"));
		        System.out.println("the author is: " + (String)docinfoProps.getPropertyValue("Author"));
		        System.out.println("the subject is: " + (String)docinfoProps.getPropertyValue("Subject"));
		        System.out.println("the description is: " + (String)docinfoProps.getPropertyValue("Description"));
		        System.out.println("the keywords are: " + (String)docinfoProps.getPropertyValue("Keywords"));

			} catch (IOException e) {
				e.printStackTrace();
			}catch(Exception e){
				e.printStackTrace();
			}
		}


}